require("datastream") -- Shamefull CapsAdmin


TOOL.Category = "Poser"
TOOL.Name = "Hat Maker"
TOOL.Command = nil
TOOL.ConfigName = ""
local tool = TOOL --eugh

TOOL.ClientConVar["FileName"] = "MyHat" --(TOOL.owner():Nick():gsub("%W", "") .. "sHat")
TOOL.ClientConVar["Model"] = "models/dav0r/hoverball.mdl"
TOOL.ClientConVar["Material"] = ""
TOOL.ClientConVar["X"] = "0"
TOOL.ClientConVar["Y"] = "0"
TOOL.ClientConVar["Z"] = "0"
TOOL.ClientConVar["Scale"] = "1"
TOOL.ClientConVar["Pitch"] = "0"
TOOL.ClientConVar["Yaw"] = "0"
TOOL.ClientConVar["Roll"] = "0"

if CLIENT then
		
		language.Add( "Tool_hatmaker_name", "Hat Maker Tool" )
		language.Add( "Tool_hatmaker_desc", "Create your own hats with a visual menu!" )
		language.Add( "Tool_hatmaker_0", "" )
		
		local BoneList = 
		{
		{"ValveBiped.Bip01_Pelvis", "Pelvis" },
		{"ValveBiped.Bip01_Spine", "Spine 1" },
		{"ValveBiped.Bip01_Spine1", "Spine 2" },
		{"ValveBiped.Bip01_Spine2", "Spine 3" },
		{"ValveBiped.Bip01_Spine4", "Spine 4" },
		{"ValveBiped.Bip01_Neck1", "Neck" },
		{"ValveBiped.Bip01_Head1", "Head" },
		{"ValveBiped.Bip01_R_Clavicle", "Right Clavicle" },
		{"ValveBiped.Bip01_R_UpperArm", "Right Upper Arm" },
		{"ValveBiped.Bip01_R_Forearm", "Right Forearm" },
		{"ValveBiped.Bip01_R_Hand", "Right Hand" },
		{"ValveBiped.Bip01_L_Clavicle", "Clavicle" },
		{"ValveBiped.Bip01_L_UpperArm", "Left Upper Arm" },
		{"ValveBiped.Bip01_L_Forearm", "Left Forearm" },
		{"ValveBiped.Bip01_L_Hand", "Left Hand" },
		{"ValveBiped.Bip01_R_Thigh", "Right Thigh" },
		{"ValveBiped.Bip01_R_Calf", "Right Calf" },
		{"ValveBiped.Bip01_R_Foot", "Right Foot" },
		{"ValveBiped.Bip01_R_Toe0", "Right Toe" },
		{"ValveBiped.Bip01_L_Thigh", "Left Thigh" },
		{"ValveBiped.Bip01_L_Calf", "Left Calf" },
		{"ValveBiped.Bip01_L_Foot", "Left Foot" },
		{"ValveBiped.Bip01_L_Toe0", "Left Toe" }
		}
		
		local function TranslateBoneToName(Panel)
			for k, v in pairs(BoneList) do
				if Panel.TextEntry:GetValue() == v[2] then
					return v[1]
				end
			end
		end
		
		concommand.Add("MakeHatClient",

		function(Player, Command, Arguments)
			local Content = string.Implode(" ", Arguments)
			file.CreateDir("HatMaker")
			file.Write("HatMaker/" .. Arguments[1] .. ".txt", Content )
		end)
	
		
		local FileList
		local WearList = {}
		local ClientWearList = {}
		 
			function tool.RefreshList()
				local CPanel = GetControlPanel( "hatmaker" )       
				CPanel:ClearControls()
				tool.BuildCPanel( CPanel, FileList, WearList )
			end
		 
		concommand.Add("HatMaker_RemoveHatsWearList",
		
		function()
			ClientWearList = {}
			WearList = {}
		end) 
		 
		 
--[[ 		usermessage.Hook("HatMaker_FileList", 
		
		function( um )
			local num_files = um:ReadLong()
			for i = 1, num_files do
				local File = um:ReadString()
				table.insert(FileList, File)
			end

			if (um:ReadBool()) then
				tool.RefreshList()
			end
		end)
		 
		usermessage.Hook("HatMaker_ResetFileList", 
		
		function( um )
			FileList = {}
		end) ]]
		
		
		
		--Shamefull CapsAdmin.
		datastream.Hook( "HatMaker_StreamToClients",
		
		function( handler, id, encoded, decoded )
			FileList = decoded
			tool.RefreshList()
		end)

	function TOOL.BuildCPanel( ContextMenu, FileList, WearList )
		FileList = FileList or {"HitRefresh!"}
		Tree = vgui.Create("DTree", ContextMenu)
		ContextMenu:AddPanel(Tree)
		Tree:SetTall(500)
		local Server = Tree:AddNode("Server")
		local Client = Tree:AddNode("Client")
		--local Wearing = Tree:AddNode("Wearing")
		
		local outfits = Client:AddNode( "Outfits" )
		
		for Index, File in pairs(FileList) do
			local File = string.sub(File, 0, -5)
			local SelectedItem = Server:AddNode(File)
			local IsWorn = false
			local WearList = WearList or {false}
			for k, v in pairs(WearList)do
				if(v == File)then
					IsWorn = true
				end
			end
			if IsWorn then
				SelectedItem:SetText("*" .. File)
			end
			SelectedItem:ExpandTo(true)
			function SelectedItem:DoClick()
				SelectedHat = File
				table.insert(WearList, SelectedHat)

				self:SetText("*" .. File)
				RunConsoleCommand("WearHat", File)
				LocalPlayer():EmitSound("ambient/materials/rock4.wav")
			end
			function SelectedItem:DoRightClick() 
				self:SetText(File)
				table.remove(WearList, Index)
				RunConsoleCommand("HatMaker_RemovePart", File)
				LocalPlayer():EmitSound("ambient/materials/rock4.wav")
			end
		end
		
		for k, v in pairs( file.FindDir( "HatMaker/outfits/*" ) ) do
		
			local item = outfits:AddNode( v )
			local worn = false
			
			local wear = wear or { false }
			
			for o, p in pairs( wear ) do
			
				if ( p == v ) then
				
					worn = true
				
				end
			
			end
			
			if ( worn ) then
			
				item:SetText( "*" .. v )
			
			end
			
			item:ExpandTo( true )
			
			function item:DoClick()
			
				for e, f in pairs( file.Find( "HatMaker/outfits/" .. v .. "/*" ) ) do
				
					local selected = f
					local outfit = string.sub( f, 0, -5 )
					table.insert( wear, selected )
					
					self:SetText( "*" .. v )
					local Content = file.Read("HatMaker/outfits/" .. v .. "/" .. f)
					local Arguments = string.Explode(" ",Content)
					local HatName = Arguments[1]
					local HatModel = Arguments[2]

					local X = Arguments[3]
					local Y = Arguments[4]
					local Z = Arguments[5]

					local Scale = Arguments[6]

					local Pitch = Arguments[7]
					local Yaw = Arguments[8]
					local Roll = Arguments[9]

					local ScaleX = Arguments[10]
					local ScaleY = Arguments[11]
					local ScaleZ = Arguments[12]

					local R = Arguments[13]
					local G = Arguments[14]
					local B = Arguments[15]
					local A = Arguments[16]

					local Bone = Arguments[17]

					local HatMaterial = Arguments[18]
					
					
					RunConsoleCommand("WearHatClient", HatName, HatModel, X, Y, Z, Scale, Pitch, Yaw, Roll, ScaleX, ScaleY, ScaleZ, R, G, B, A, Bone, HatMaterial)
					
					LocalPlayer():EmitSound( "ambient/materials/rock4.wav" )
				
				end
			
			end
			
			function item:DoRightClick()
			
				for e, f in pairs( file.Find( "HatMaker/outfits/" .. v .. "/*" ) ) do
				
					local outfit = string.sub( f, 0, -5 )
				
					table.remove( wear, k )
					
					self:SetText( v )
					
					RunConsoleCommand( "HatMaker_RemovePart", outfit )
					LocalPlayer():EmitSound( "ambient/materials/rock4.wav" )
				
				end
			
			end
		
		end

		for Index, File in pairs(file.Find("HatMaker/*.txt")) do
			File = string.sub(File, 0, -5)
			local ClientSelectedItem = Client:AddNode(File)
			local ClientIsWorn = false
			local ClientWearList = ClientWearList or {false}
			for k, v in pairs(ClientWearList)do
				if(v == File)then
					ClientIsWorn = true
				end
			end
			if ClientIsWorn then
				ClientSelectedItem:SetText("*" .. File)
			end
			 function ClientSelectedItem:DoClick()
				SelectedHat = File
				local Content = file.Read("HatMaker/" .. File .. ".txt")
				
				local Arguments = string.Explode(" ",Content)
				local HatName = Arguments[1]
				local HatModel = Arguments[2]

				local X = Arguments[3]
				local Y = Arguments[4]
				local Z = Arguments[5]

				local Scale = Arguments[6]

				local Pitch = Arguments[7]
				local Yaw = Arguments[8]
				local Roll = Arguments[9]

				local ScaleX = Arguments[10]
				local ScaleY = Arguments[11]
				local ScaleZ = Arguments[12]

				local R = Arguments[13]
				local G = Arguments[14]
				local B = Arguments[15]
				local A = Arguments[16]

				local Bone = Arguments[17]

				local HatMaterial = Arguments[18]
				self:SetText("*" .. File)
				table.insert(ClientWearList, SelectedHat)
				RunConsoleCommand("WearHatClient", HatName, HatModel, X, Y, Z, Scale, Pitch, Yaw, Roll, ScaleX, ScaleY, ScaleZ, R, G, B, A, Bone, HatMaterial)
				LocalPlayer():ConCommand("play ambient/materials/rock4.wav")
			end
			function ClientSelectedItem:DoRightClick() 
				self:SetText(File)
				table.remove(ClientWearList, Index)
				RunConsoleCommand("HatMaker_RemovePart", File)
				LocalPlayer():ConCommand("play ambient/materials/rock4.wav")
			end
		end
				
		ContextMenu:AddControl("Button", 
		{
			Label = "Open Editor",
			Command = "HatMaker"
		})
		
		local Button = vgui.Create( "DButton", ContextMenu )
		ContextMenu:AddPanel(Button)
		Button:SetText( "Remove everything you are wearing" )
		Button.DoClick = 
		function()
			RunConsoleCommand("HatMaker_RemoveHatsWearList")
			RunConsoleCommand("HatMaker_RemoveHats")
			RunConsoleCommand("HatMaker_Refresh")
		end
		ContextMenu:AddControl("Button", 
		{
			Label = "Refresh",
			Command = "HatMaker_Refresh"
		})
		
		concommand.Add("HatMaker",
		
		function()
			local MainFrame = vgui.Create("DFrame")
			MainFrame:SetSize( 850, 550)
			MainFrame:Center()
			MainFrame:SetTitle( "Hat Maker" )
			MainFrame:ShowCloseButton( true )
			MainFrame:SetVisible( true )
			MainFrame:MakePopup()
			MainFrame:SetDraggable(true)
			
			local ModelPanel = vgui.Create( "DModelPanelHatMaker", MainFrame )
		
			ModelPanel:SetModel( LocalPlayer():GetModel(), "models/dav0r/hoverball.mdl" )
			ModelPanel:SetPos(20,21)
			ModelPanel:SetSize(400, 400) 
			ModelPanel:SetCamPos(Vector( 0, 50, 60 ))
			ModelPanel:SetLookAt(Vector( 0, 0, 65 ))
			ModelPanel:SetFOV(40)
			
			local Entity = ModelPanel:GetEntity()
			local Model = ModelPanel:GetHatEntity()
			Model:SetModel(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWString("hatmodel"))
			Model:SetMaterial(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWString("hatmaterial"))
			
			local ModelText = vgui.Create( "DLabel", MainFrame )
			ModelText:SetText("Paste your model path here:")
			ModelText:SetPos(20,435)
			ModelText:SizeToContents()
			
			local ModelEntry = vgui.Create( "DTextEntry", MainFrame )
			ModelEntry:SetPos(20,450)
			ModelEntry:SetSize(400,20)
			ModelEntry:SetText(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWString("hatmodel") or "models/dav0r/hoverball.mdl")
			ModelEntry.OnEnter = 
			function() 
				Model:SetModel(ModelEntry:GetValue()) 
			end
			
			local MaterialText = vgui.Create( "DLabel", MainFrame )
			MaterialText:SetText("Paste your material path here:")
			MaterialText:SetPos(20,485) 
			MaterialText:SizeToContents()
			
			local MaterialEntry = vgui.Create( "DTextEntry", MainFrame )
			MaterialEntry:SetPos(20,500)
			MaterialEntry:SetSize(400,20)
			MaterialEntry:SetText(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWString("hatmaterial") or "NoMaterial")
			MaterialEntry.OnEnter = 
			function() 
				Model:SetMaterial(MaterialEntry:GetValue()) 
			end
				
			local XYSlider = vgui.Create("DSlider", MainFrame)
			XYSlider:SetSize(400,400)
			XYSlider:SetPos(20,21)
			
	 		local ColorMixer = vgui.Create( "DColorMixerHatMaker", MainFrame)
			ColorMixer:SetSize( 160, 100 )
			ColorMixer:SetPos( 650, 50 )
			local R,G,B,A = LocalPlayer():GetNWEntity("hatmaker_entity"):GetColor()
			ColorMixer:SetColor(Color(R,G,B,A))
			local SaveText = vgui.Create( "DLabel", MainFrame )
			SaveText:SetText("Filename:")
			SaveText:SetPos(450,423)
			SaveText:SizeToContents()
			
			local FileName = vgui.Create( "DTextEntry", MainFrame )
			FileName:SetPos(450,450)
			FileName:SetSize(150,20)
			FileName:SetText("")
				
			local MinMax = 50
			local Right = 450
			local VectorXSlider = vgui.Create( "DNumSlider", MainFrame )
			VectorXSlider:SetPos( Right,50 )
			VectorXSlider:SetSize( 150, 100 )
			VectorXSlider:SetText( "Offset X" )
			VectorXSlider:SetMin( -MinMax )
			VectorXSlider:SetMax( MinMax )
			VectorXSlider:SetValue(-LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWVector("offsetvector").x or 0)
			
			local VectorYSlider = vgui.Create( "DNumSlider", MainFrame )
			VectorYSlider:SetPos( Right,100 )
			VectorYSlider:SetSize( 150, 100 )
			VectorYSlider:SetText( "Offset Y" )
			VectorYSlider:SetMin( -MinMax )
			VectorYSlider:SetMax( MinMax )
			VectorYSlider:SetValue(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWVector("offsetvector").y or 0)
			
			local VectorZSlider = vgui.Create( "DNumSlider", MainFrame )
			VectorZSlider:SetPos( Right,150 )
			VectorZSlider:SetSize( 150, 100 )
			VectorZSlider:SetText( "Offset Z" )
			VectorZSlider:SetMin( -MinMax )
			VectorZSlider:SetMax( MinMax )
			VectorZSlider:SetValue(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWVector("offsetvector").z or 0)
			
			local ModelScale = vgui.Create( "DNumSlider", MainFrame )
			ModelScale:SetPos( 650, 200 )
			ModelScale:SetSize( 150, 100 )
			ModelScale:SetText( "Model Scale" )
			ModelScale:SetMin( 0 )
			ModelScale:SetMax( 10 )
			ModelScale:SetValue(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWFloat("scale") or 1)
			
			local ModelScaleX = vgui.Create( "DNumSlider", MainFrame )
			ModelScaleX:SetPos( 650, 250 )
			ModelScaleX:SetSize( 150, 100 )
			ModelScaleX:SetText( "Scale X" )
			ModelScaleX:SetMin( 0 )
			ModelScaleX:SetMax( 10 )
			ModelScaleX:SetValue(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWVector("scalevector").x or 1)

			local ModelScaleY = vgui.Create( "DNumSlider", MainFrame )
			ModelScaleY:SetPos( 650, 300 )
			ModelScaleY:SetSize( 150, 100 )
			ModelScaleY:SetText( "Scale Y" )
			ModelScaleY:SetMin( 0 )
			ModelScaleY:SetMax( 10 )
			ModelScaleY:SetValue(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWVector("scalevector").y or 1)
			
			local ModelScaleZ = vgui.Create( "DNumSlider", MainFrame )
			ModelScaleZ:SetPos( 650, 350 )
			ModelScaleZ:SetSize( 150, 100 )
			ModelScaleZ:SetText( "Scale Z" )
			ModelScaleZ:SetMin( 0 )
			ModelScaleZ:SetMax( 10 )
			ModelScaleZ:SetValue(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWVector("scalevector").z or 1)

			local SelectBone = vgui.Create( "DMultiChoice", MainFrame )
			SelectBone:SetPos(650, 400)
			SelectBone:SetSize(150,21)
			
			local Text
			for k, v in pairs(BoneList) do
				if v[1] == LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWString("bone") then
					Text = v[2]
				end
			end
			SelectBone:SetText(Text or "")
			SelectBone:SetEditable(false)
			for Index, Bone in pairs(BoneList) do
				SelectBone:AddChoice(Bone[2])
			end
			
			local MinMax = 180
			local AnglePitchSlider = vgui.Create( "DNumSlider", MainFrame )
			AnglePitchSlider:SetPos( Right, 250 )
			AnglePitchSlider:SetSize( 150, 100 )
			AnglePitchSlider:SetText( "Pitch" )
			AnglePitchSlider:SetMin( -MinMax )
			AnglePitchSlider:SetMax( MinMax )
			AnglePitchSlider:SetValue(-LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWAngle("angles").p or 0)
			
			local AngleYawSlider = vgui.Create( "DNumSlider", MainFrame )
			AngleYawSlider:SetPos( Right, 300 )
			AngleYawSlider:SetSize( 150, 100 )
			AngleYawSlider:SetText( "Yaw" )
			AngleYawSlider:SetMin( -MinMax )
			AngleYawSlider:SetMax( MinMax )
			AngleYawSlider:SetValue(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWAngle("angles").y or 0)
			
 			local AngleRollSlider = vgui.Create( "DNumSlider", MainFrame )
			AngleRollSlider:SetPos( Right, 350 )
			AngleRollSlider:SetSize( 150, 100 )
			AngleRollSlider:SetText( "Roll" )
			AngleRollSlider:SetMin( -MinMax )
			AngleRollSlider:SetMax( MinMax )
			AngleRollSlider:SetValue(LocalPlayer():GetNWEntity("hatmaker_entity"):GetNWAngle("angles").r or 0)
			
			local Save = vgui.Create( "DButton", MainFrame )
			Save:SetSize( 150, 20 )
			Save:SetPos( 450, 500 )
			Save:SetText( "Save to server" )
			Save.DoClick = 
			function()
				local FileName = FileName:GetValue():gsub("[%W]", "")
				local HatModel = Model:GetModel() or "models/dav0r/hoverball.mdl"
			
				local X = -VectorXSlider:GetValue() 
				local Y = VectorYSlider:GetValue()
				local Z = VectorZSlider:GetValue()
				
				local Scale = ModelScale:GetValue()
				local ScaleX = ModelScaleX:GetValue() 
				local ScaleY = ModelScaleY:GetValue()
				local ScaleZ = ModelScaleZ:GetValue()
				
				local R = ColorMixer:GetColor().r
				local G = ColorMixer:GetColor().g
				local B = ColorMixer:GetColor().b
				local A = ColorMixer:GetColor().a
				
				local Pitch = -AnglePitchSlider:GetValue() 
				local Yaw = AngleYawSlider:GetValue()
				local Roll = AngleRollSlider:GetValue()
				
			
				local Bone = TranslateBoneToName(SelectBone)

					
				local HatMaterial = MaterialEntry:GetValue()
				RunConsoleCommand(
				"MakeHat", 
				FileName, 
				HatModel, 
				
				X, 
				Y, 
				Z, 
				
				Scale, 
				
				Pitch, 
				Yaw, 
				Roll, 
				
				ScaleX, 
				ScaleY, 
				ScaleZ, 
				
				R, 
				G, 
				B, 
				A, 
				
				Bone,
				HatMaterial)
			end
			
			local ClientSave = vgui.Create( "DButton", MainFrame )
			ClientSave:SetSize( 150, 20 )
			ClientSave:SetPos( 450, 475 )
			ClientSave:SetText( "Save to Client" )
			ClientSave.DoClick = 
			function()
				local FileName = FileName:GetValue():gsub("[%W]", "")
				local HatModel = Model:GetModel() or "models/dav0r/hoverball.mdl"
			
				local X = -VectorXSlider:GetValue() 
				local Y = VectorYSlider:GetValue()
				local Z = VectorZSlider:GetValue()
				
				local Scale = ModelScale:GetValue()
				local ScaleX = ModelScaleX:GetValue() 
				local ScaleY = ModelScaleY:GetValue()
				local ScaleZ = ModelScaleZ:GetValue()
				
				local R = ColorMixer:GetColor().r
				local G = ColorMixer:GetColor().g
				local B = ColorMixer:GetColor().b
				local A = ColorMixer:GetColor().a
				
				local Pitch = -AnglePitchSlider:GetValue() 
				local Yaw = AngleYawSlider:GetValue()
				local Roll = AngleRollSlider:GetValue()
							
				local Bone = TranslateBoneToName(SelectBone)
				
				
				local HatMaterial = MaterialEntry:GetValue()
				RunConsoleCommand(
				"MakeHatClient", 
				FileName, 
				HatModel, 
				
				X, 
				Y, 
				Z, 
				
				Scale, 
				
				Pitch, 
				Yaw, 
				Roll, 
				
				ScaleX, 
				ScaleY, 
				ScaleZ, 
				
				R, 
				G, 
				B, 
				A,
				
				Bone,
				
				HatMaterial)
			end
		
			function MainFrame:Think()
				Entity:SetAngles(Angle(0,XYSlider:GetSlideX()*360-90 or 0,0))
				ModelPanel:SetFOV(math.Clamp(XYSlider:GetSlideY()*100, 20, 100))
				local Part = TranslateBoneToName(SelectBone)

				local Bone = Entity:LookupBone(Part or "ValveBiped.Bip01_Head1")
				if Bone then
					local Position, Angles = Entity:GetBonePosition(Bone)
					ModelPanel:SetLookAt(Vector(Position.x,Position.y,Position.z))		
					local X = Angles:Up() * -VectorXSlider:GetValue() 
					local Y = Angles:Right() * VectorYSlider:GetValue()
					local Z = Angles:Forward() * VectorZSlider:GetValue() 
					
					local Pitch = -AnglePitchSlider:GetValue() 
					local Yaw = AngleYawSlider:GetValue()
					local Roll = AngleRollSlider:GetValue() 
					
					local R = ColorMixer:GetColor().r
					local G = ColorMixer:GetColor().g
					local B = ColorMixer:GetColor().b
					local A = ColorMixer:GetColor().a
					
					Angles:RotateAroundAxis(Angles:Forward(), Pitch)
                    Angles:RotateAroundAxis(Angles:Right(), Yaw)
                    Angles:RotateAroundAxis(Angles:Up(), Roll)
					
					Model:SetPos(Position + X + Y + Z)
					Model:SetAngles(Angles)
					ModelPanel:SetHatColor(R,G,B,A)
					Model:SetModelScale(Vector(ModelScaleX:GetValue(),ModelScaleY:GetValue(),ModelScaleZ:GetValue()) * ModelScale:GetValue())
				end
			end
		end)
	end	
end

if SERVER then
	
	hook.Add("PlayerInitialSpawn", "HatMakerPlayerSpawn",
	function( Player )
		Player.Hats = {}
	end)
	
--[[ 	local function SendText( txt )
	 
		local rp = RecipientFilter()
		rp:AddAllPlayers()

		local files = #txt
		local file = 0
 
		umsg.Start("HatMaker_ResetFileList", rp)
		umsg.End()
 
		timer.Create("HatMaker_umsg_timer", 0.3, files,
		function()
	---	while files > 0 do
			local sending = math.min(files, 8)
			print(files, sending)
			umsg.Start("HatMaker_FileList", rp)
			umsg.Long( sending )
			
			--timer.Create("HatMaker_umsg_timer2", 0.3, sending,
			--function()
			for i = 1, sending do
				file = file + 1
				umsg.String( txt[file] )
			end--)
			
			umsg.Bool(files == sending)
			umsg.End()
			files = files - sending
		end)
	end
	
	hook.Add("PlayerSpawn", "HatMaker_SpawnRefresh",
	
	function()
		SendText(file.Find("HatMaker/*.txt"))	
	end)
	
	concommand.Add("HatMaker_Refresh",
	
	function(Player)
		SendText(file.Find("HatMaker/*.txt"))
	end) ]]
	
	hook.Add("PlayerSpawn", "HatMaker_SpawnRefresh",
	
	function()
		HatMaker_Refresh()	
	end)
	
	concommand.Add("HatMaker_Refresh",
	function()
		HatMaker_Refresh()
	end)
	
	function HatMaker_Refresh()
		local META = FindMetaTable("CRecipientFilter")   
		function META:IsValid()   
			return true   
		end  
		--Shamefull CapsAdmin
		for key, value in pairs(player.GetAll()) do
			datastream.StreamToClients(value, "HatMaker_StreamToClients",	file.Find("HatMaker/*.txt"))
		end
		--datastream is broken so I can't use player.GetAll() and I have to make CRecipientFilter always return true what the fuck
	end
	
	concommand.Add("MakeHat",

	function(Player, Command, Arguments)
		local Content = string.Implode(" ", Arguments)
		file.CreateDir("HatMaker")
		file.Write("HatMaker/" .. Arguments[1] .. ".txt", Content )
		SendText(file.Find("HatMaker/*.txt"))
	end)
	
	concommand.Add("WearHat",

	function(Player, Command, FileName)
		for Index, Value in pairs(Player.Hats) do
			if(Value.HatName == FileName)then
				Value:Remove()
				Value = nil
				return
			end
		end
		
		local Content = file.Read("HatMaker/" .. FileName[1] .. ".txt")
		local Arguments = string.Explode(" ", Content)
		local HatName = Arguments[1]
		local HatModel = Arguments[2]
		
		local X = Arguments[3]
		local Y = Arguments[4]
		local Z = Arguments[5]
		
		local Scale = Arguments[6]
		
		local Pitch = Arguments[7]
		local Yaw = Arguments[8]
		local Roll = Arguments[9]
		
		local ScaleX = Arguments[10]
		local ScaleY = Arguments[11]
		local ScaleZ = Arguments[12]
		
		local R = Arguments[13]
		local G = Arguments[14]
		local B = Arguments[15]
		local A = Arguments[16]
		
		local Bone = Arguments[17]
		
		local HatMaterial = Arguments[18]
		
		local HatNumber = #Player.Hats + 1
				
		Player.Hats[HatNumber] = ents.Create("HatMaker_Hat")
		Player.Hats[HatNumber]:SetModel(HatModel)
		Player.Hats[HatNumber]:SetMaterial(HatMaterial)
		
		Player.Hats[HatNumber]:SetOwner(Player)
		
		Player.Hats[HatNumber].HatName = Arguments[1]
		
		Player.Hats[HatNumber]:SetPos(Player:GetPos())
		Player.Hats[HatNumber]:SetParent(Player)
		
		Player.Hats[HatNumber]:SetNWString("hatmodel", HatModel)
		Player.Hats[HatNumber]:SetNWString("hatmaterial", HatMaterial)
		Player.Hats[HatNumber]:SetNWString("bone", Bone)
		Player.Hats[HatNumber]:SetNWVector("offsetvector", Vector(X,Y,Z))	
		Player.Hats[HatNumber]:SetNWFloat("scale", Scale)
		Player.Hats[HatNumber]:SetNWAngle("angles", Angle(Pitch,Yaw,Roll))
		Player.Hats[HatNumber]:SetNWVector("scalevector", Vector(ScaleX,ScaleY,ScaleZ))		
		Player.Hats[HatNumber]:SetColor(R,G,B,A)
		
		Player.Hats[HatNumber]:Spawn()
		Player.Hats[HatNumber]:SetNotSolid(true)
		Player:SetNWEntity("hatmaker_entity", Player.Hats[HatNumber])
		
	end)
	
	concommand.Add("WearHatClient",

	function(Player, Command, Arguments)
		for Index, Value in pairs(Player.Hats) do
			if(Value.HatName == FileName)then
				if ValidEntity(Value) then
					Value:Remove()
					Value = nil
				else
					Value = nil
				end
			end
		end
		
		local HatName = Arguments[1]
		local HatModel = Arguments[2]
		
		local X = Arguments[3]
		local Y = Arguments[4]
		local Z = Arguments[5]
		
		local Scale = Arguments[6]
		
		local Pitch = Arguments[7]
		local Yaw = Arguments[8]
		local Roll = Arguments[9]
		
		local ScaleX = Arguments[10]
		local ScaleY = Arguments[11]
		local ScaleZ = Arguments[12]
		
		local R = Arguments[13]
		local G = Arguments[14]
		local B = Arguments[15]
		local A = Arguments[16]
		
		local Bone = Arguments[17]
		
		local HatMaterial = Arguments[18]
		
		local HatNumber = #Player.Hats + 1
				
		Player.Hats[HatNumber] = ents.Create("HatMaker_Hat")
		Player.Hats[HatNumber]:SetModel(HatModel)
		Player.Hats[HatNumber]:SetMaterial(HatMaterial)
		
		Player.Hats[HatNumber]:SetOwner(Player)
		
		Player.Hats[HatNumber].HatName = Arguments[1]
		
		Player.Hats[HatNumber]:SetPos(Player:GetPos())
		Player.Hats[HatNumber]:SetParent(Player)
		
		Player.Hats[HatNumber]:SetNWString("hatmodel", HatModel)
		Player.Hats[HatNumber]:SetNWString("hatmaterial", HatMaterial)
		Player.Hats[HatNumber]:SetNWString("bone", Bone)
		Player.Hats[HatNumber]:SetNWVector("offsetvector", Vector(X,Y,Z))
		Player.Hats[HatNumber]:SetNWFloat("scale", Scale)
		Player.Hats[HatNumber]:SetNWAngle("angles", Angle(Pitch,Yaw,Roll))
		Player.Hats[HatNumber]:SetNWVector("scalevector", Vector(ScaleX,ScaleY,ScaleZ))
		Player.Hats[HatNumber]:SetColor(R,G,B,A)
		
		Player.Hats[HatNumber]:Spawn()
		Player.Hats[HatNumber]:SetNotSolid(true)
		Player:SetNWEntity("hatmaker_entity", Player.Hats[HatNumber])
		
	end)
	
	concommand.Add("HatMaker_RemoveHats",

	function(Player, Command, Arguments)
		for i = 1, #Player.Hats do
			for Index, hat in pairs(Player.Hats)do
				if ValidEntity(hat) then
					hat:Remove()
					table.remove(Player.Hats, Index)
				end
			end
		end
	end)
	
	concommand.Add("HatMaker_RemovePart",

	function(Player, Command, Arguments)
		for _, v in pairs(Player.Hats) do
			local Name = Arguments[1]	
			if(v.HatName == Name)then
				v:Remove()
				v = nil
			end
		end
	end)
end